data "archive_file" "rewrite" {
  type        = "zip"
  output_path = "${path.module}/dist/rewrite_lambda.zip"

  source {
    filename = "index.js"
    content  = "${file("${path.module}/rewrite_lambda.js")}"
  }
}

resource "aws_lambda_function" "rewrite" {
  function_name = "${var.app_name}-rewrite"

  provider         = "aws.us_east_1"
  filename         = "${data.archive_file.rewrite.output_path}"
  source_code_hash = "${data.archive_file.rewrite.output_base64sha256}"
  role             = "${aws_iam_role.rewrite.arn}"
  runtime          = "nodejs6.10"
  handler          = "index.handler"
  memory_size      = 128
  timeout          = 3
  publish          = true
}

resource "aws_iam_role" "rewrite" {
  name = "${var.app_name}-rewrite-role"

  assume_role_policy = <<EOF
{
  "Version": "2012-10-17",
  "Statement": [
    {
      "Effect": "Allow",
      "Principal": {
        "Service": [
          "edgelambda.amazonaws.com",
          "lambda.amazonaws.com"
        ]
      },
      "Action": "sts:AssumeRole"
    }
  ]
}
EOF
}
